import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ListToArrayDemo {

  public static void main(String[] args) {
    LinkedList<Character> lst = new LinkedList<>();
    lst.insertAtHead('a');
    lst.insertAtHead('b');
    lst.insertAtHead('B');
    lst.insertAtHead('A');

    for (char c : lst) {
      System.out.print(c); // (2)
    }
    System.out.println();

    Character[] array = new Character[lst.numberOfNodes()];
    lst.listToArray(array);
    System.out.println(array.length);
    for (Character c : array) {
      System.out.print(c);            // (1)
    }
    System.out.println();

    for (int i = 0; i < array.length; i++) {
      System.out.print(array[i]);    // (2)
    }
    System.out.println();

    System.out.println(Arrays.toString(array));
    System.out.println();

    List<Character> myList = arrayToList(array);
    for (char c : lst) {
      System.out.print(c);           // (3)
    }
    System.out.println();
    System.out.println(myList);
  }

  public static <T> List<T> arrayToList(T[] array) {
    List<T> list = new ArrayList<>();
    for (T data : array) {
      list.add(data);
    }
    return list;
  }

  // Following versions not recommended.
  public static List arrayToListV1(Object[] array) {
    List<Object> list = new ArrayList<>();
    for (Object data : array) {
      list.add(data);
    }
    return list;
  }

  public static List arrayToListV2(Object[] array) {
    List list = new ArrayList();
    for (Object data : array) {
      list.add(data);
    }
//  list.add("rubbish");
    return list;
  }

  public static List arrayToListV3(Object[] array) {
    List<String> list = new ArrayList<>();
    for (String data : (String[]) array) {
      list.add(data);
    }
    return list;
  }
}