/** A node holds data and a reference to a node. */
public class Node<E> {

  /** Data in the node. */
  private E data;
  /** Reference to the next node. */
  private Node<E> next;

  /**
   * The constructor initializes the current node with data
   * and reference to the next node.
   * @param data_obj Data to be stored in the current node.
   * @param nodeRef  Reference to the next node that is
   *                 stored in the current node.
   */
  public Node(E data_obj, Node<E> nodeRef) {
    this.data = data_obj;
    this.next = nodeRef;
  }

  /** Set data in the current node. */
  public void setData(E obj) { this.data = obj; }

  /** Set reference to the next node in the current node. */
  public void setNext(Node<E> node) { this.next = node; }

  /** Get data stored in the current node.
   *  @return Data in the current node */
  public E getData() { return this.data; }

  /** Get reference to the next node from the current node.
   *  @return Reference to the next node */
  public Node<E> getNext() { return this.next; }
}